__kernel void convolution(__global unsigned char* I, 
                          __global unsigned char* O, 
                          int h, int w,
                          __global float* F, 
                          float factor, float bias, int s) {

    int x = get_global_id(0);
    int y = get_global_id(1);

    if (x >= w || y >= h) return;

    int u, v;
    
    float val = 0;
    
    for (u=0; u<s; u++)
        for (v=0; v<s; v++) {
            int iy = y-s/2+u;
            int ix = x-s/2+v;
            if (iy < 0 || iy>= h || ix < 0 || ix >=w) continue;
            val = val + factor*I[iy*w + ix]*F[u*s+v];
        }
    
    int res = bias + val;
    
    if (res < 0)        res = 0;
    else if (res > 255) res = 255;
    
    O[y*w+x] = res; // O[y][x] <-> pixel di coord. (x,y)
}

