#define IDX(i,j,n) ((i)*(n)+(j))

__kernel void matrix_add(__global const int *I, 
                         __global int *O, 
                         int n) {
    
    // Get the index of the current element to be processed
    int i = get_global_id(0);
    int j = get_global_id(1);

    if (i>=n || j>=n) return;
    
    // Do the operation
    int v = I[IDX(i,j,n)];
    O[IDX(2*i,   2*j,   2*n)] = v;
    O[IDX(2*i+1, 2*j,   2*n)] = v;
    O[IDX(2*i,   2*j+1, 2*n)] = v;
    O[IDX(2*i+1, 2*j+1, 2*n)] = v;
}
